﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using LinqtoCRMApplication.CRM;

namespace LinqtoCRM
{
    public class CrmWebService :  ICrmService
    {
        private CrmService _service;

        public CrmWebService(CrmService service)
        {
            _service = service;            
        }

        #region ICrmService Members

        public string Fetch(string fetchXml)
        {
            return _service.Fetch(fetchXml);
        }

        public System.Net.ICredentials Credentials
        {
            get
            {
                return _service.Credentials;
            }
            set
            {
                _service.Credentials = value;
            }
        }

        public string Url
        {
            get
            {
                return _service.Url;
            }
            set
            {
                _service.Url = value;
            }
        }
        #endregion
        
    }
}
